/**
 * Angular directive/filter/service for formatting date so that it displays how long ago the given time was compared to now.
 * @version v0.2.6 - 2016-04-04
 * @link https://github.com/yaru22/angular-timeago
 * @author Brian Park <yaru22@gmail.com>
 * @license MIT License, http://www.opensource.org/licenses/MIT
 */
"use strict";angular.module("yaru22.angular-timeago",[]).directive("timeAgo",["timeAgo","nowTime",function(a,b){return{scope:{fromTime:"@",format:"@"},restrict:"EA",link:function(c,d){var e=a.parse(c.fromTime);c.$watch(function(){return b()-e},function(b){angular.element(d).text(a.inWords(b,e,c.format))})}}}]).factory("nowTime",["$timeout",function(a){function b(){c=Date.now(),a(b,1e3)}var c;return b(),function(){return c}}]).factory("timeAgo",["$filter",function(a){var b={};return b.settings={refreshMillis:6e4,allowFuture:!1,overrideLang:null,fullDateAfterSeconds:null,strings:{it_IT:{prefixAgo:null,prefixFromNow:null,suffixAgo:"fa",suffixFromNow:"da ora",seconds:"meno di un minuto",minute:"circa un minuto",minutes:"%d minuti",hour:"circa un' ora",hours:"circa %d ore",day:"un giorno",days:"%d giorni",month:"circa un mese",months:"%d mesi",year:"circa un anno",years:"%d anni",numbers:[]},en_US:{prefixAgo:null,prefixFromNow:null,suffixAgo:"ago",suffixFromNow:"from now",seconds:"less than a minute",minute:"about a minute",minutes:"%d minutes",hour:"about an hour",hours:"about %d hours",day:"a day",days:"%d days",month:"about a month",months:"%d months",year:"about a year",years:"%d years",numbers:[]},de_DE:{prefixAgo:"vor",prefixFromNow:"in",suffixAgo:null,suffixFromNow:null,seconds:"weniger als einer Minute",minute:"ca. einer Minute",minutes:"%d Minuten",hour:"ca. einer Stunde",hours:"ca. %d Stunden",day:"einem Tag",days:"%d Tagen",month:"ca. einem Monat",months:"%d Monaten",year:"ca. einem Jahr",years:"%d Jahren",numbers:[]},he_IL:{prefixAgo:null,prefixFromNow:null,suffixAgo:"לפני",suffixFromNow:"מעכשיו",seconds:"פחות מדקה",minute:"כדקה",minutes:"%d דקות",hour:"כשעה",hours:"כ %d שעות",day:"יום",days:"%d ימים",month:"כחודש",months:"%d חודשים",year:"כשנה",years:"%d שנים",numbers:[]},pt_BR:{prefixAgo:null,prefixFromNow:"daqui a",suffixAgo:"atrás",suffixFromNow:null,seconds:"menos de um minuto",minute:"cerca de um minuto",minutes:"%d minutos",hour:"cerca de uma hora",hours:"cerca de %d horas",day:"um dia",days:"%d dias",month:"cerca de um mês",months:"%d meses",year:"cerca de um ano",years:"%d anos",numbers:[]},ca_ES:{prefixAgo:"fa",prefixFromNow:"d'aquí",suffixAgo:null,suffixFromNow:null,seconds:"menys d'un minut",minute:"prop d'un minut",minutes:"%d minuts",hour:"prop d'una hora",hours:"prop de %d hores",day:"un dia",days:"%d dies",month:"prop d'un mes",months:"%d mesos",year:"prop d'un any",years:"%d anys",numbers:[]},fr_FR:{prefixAgo:"il y a",prefixFromNow:"dans",suffixAgo:null,suffixFromNow:null,seconds:"moins d'une minute",minute:"environ une minute",minutes:"%d minutes",hour:"environ une heure",hours:"environ %d heures",day:"un jour",days:"%d jours",month:"environ un mois",months:"%d mois",year:"environ un an",years:"%d ans",numbers:[]},es_LA:{prefixAgo:"hace",prefixFromNow:"en",suffixAgo:null,suffixFromNow:null,seconds:"menos de un minuto",minute:"un minuto",minutes:"%d minutos",hour:"una hora",hours:"%d horas",day:"un día",days:"%d días",month:"un mes",months:"%d meses",year:"un año",years:"%d años",numbers:[]},nl_NL:{prefixAgo:null,prefixFromNow:"over",suffixAgo:"geleden",suffixFromNow:"vanaf nu",seconds:"een paar seconden",minute:"ongeveer een minuut",minutes:"%d minuten",hour:"een uur",hours:"%d uur",day:"een dag",days:"%d dagen",month:"een maand",months:"%d maanden",year:"een jaar",years:"%d jaar",numbers:[]},zh_TW:{wordSeparator:"",prefixAgo:null,prefixFromNow:null,suffixAgo:"前",suffixFromNow:"後",seconds:"少於一分鐘",minute:"一分鐘",minutes:"%d分鐘",hour:"一小時",hours:"%d小時",day:"一日",days:"%d日",month:"一個月",months:"%d個月",year:"一年",years:"%d年",numbers:["零","一","二","三","四","五","六","七","八","九","十","十一","十二","十三","十四","十五","十六","十七","十八","十九","二十","廿一","廿二","廿三","廿四","廿五","廿六","廿七","廿八","廿九","三十","卅一","卅二","卅三","卅四","卅五","卅六","卅七","卅八","卅九","四十","卌一","卌二","卌三","卌四","卌五","卌六","卌七","卌八","卌九","五十","五十一","五十二","五十三","五十四","五十五","五十六","五十七","五十八","五十九","六十","六十一","六十二","六十三","六十四","六十五","六十六","六十七","六十八","六十九","七十","七十一","七十二","七十三","七十四","七十五","七十六","七十七","七十八","七十九","八十","八十一","八十二","八十三","八十四","八十五","八十六","八十七","八十八","八十九","九十","九十一","九十二","九十三","九十四","九十五","九十六","九十七","九十八","九十九","一百"]},sv_SE:{prefixAgo:null,prefixFromNow:"om",suffixAgo:"sen",suffixFromNow:null,seconds:"mindre än en minut",minute:"cirka en minut",minutes:"%d minuter",hour:"cirka en timme",hours:"cirka %d timmar",day:"en dag",days:"%d dagar",month:"cirka en månad",months:"%d månader",year:"cirka ett år",years:"%d år",numbers:[]}}},b.inWords=function(c,d,e,f){function g(a,b){var d=angular.isFunction(a)?a(b,c):a,e=k.numbers&&k.numbers[b]||b;return d.replace(/%d/i,e)}var h=parseInt(b.settings.fullDateAfterSeconds,10);if(!isNaN(h)){var i=1e3*h;if(c>=0&&c>=i||0>c&&i>=c)return e?a("date")(d,e,f):d}var j,k,l=b.settings.overrideLang,m=document.documentElement.lang,n=b.settings.strings;"undefined"!=typeof n[l]?(j=l,k=n[l]):"undefined"!=typeof n[m]?(j=m,k=n[m]):(j="en_US",k=n[j]);var o=k.prefixAgo,p=k.suffixAgo;b.settings.allowFuture&&0>c&&(o=k.prefixFromNow,p=k.suffixFromNow);var q=Math.abs(c)/1e3,r=q/60,s=r/60,t=s/24,u=t/365,v=45>q&&g(k.seconds,Math.round(q))||90>q&&g(k.minute,1)||45>r&&g(k.minutes,Math.round(r))||90>r&&g(k.hour,1)||24>s&&g(k.hours,Math.round(s))||42>s&&g(k.day,1)||30>t&&g(k.days,Math.round(t))||45>t&&g(k.month,1)||365>t&&g(k.months,Math.round(t/30))||1.5>u&&g(k.year,1)||g(k.years,Math.round(u)),w=void 0===k.wordSeparator?" ":k.wordSeparator;return"he_IL"===j?[o,p,v].join(w).trim():[o,v,p].join(w).trim()},b.parse=function(a){if(a instanceof Date)return a;if(angular.isNumber(a))return new Date(a);if(/^\d+$/.test(a))return new Date(parseInt(a,10));var b=(a||"").trim();return b=b.replace(/\.\d+/,""),b=b.replace(/-/,"/").replace(/-/,"/"),b=b.replace(/T/," ").replace(/Z/," UTC"),b=b.replace(/([\+\-]\d\d)\:?(\d\d)/," $1$2"),new Date(b)},b}]).filter("timeAgo",["nowTime","timeAgo",function(a,b){return function(c,d,e){var f=b.parse(c),g=a()-f;return b.inWords(g,f,d,e)}}]);